package org.fouram.controller;

import java.util.Date;

import org.fouram.core.base.controller.BaseController;
import org.fouram.core.util.AppUtil;
import org.fouram.core.util.AppUtil.ResultConstant;
import org.fouram.core.util.DateUtil;
import org.fouram.core.util.LoggerUtil;
import org.fouram.service.SapApprovalInfoService;
import org.fouram.service.SapCheckOptionService;
import org.fouram.service.SapCheckService;
import org.fouram.service.SapEmployeeTimeService;
import org.fouram.service.WxDepartService;
import org.fouram.service.WxUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping(value = "/report")
public class ReportController extends BaseController {

	@Autowired
	private WxUserService wxUserService;
	@Autowired
	private WxDepartService wxDepartService;
	@Autowired
	private SapCheckService sapCheckService;
	@Autowired
	private SapCheckOptionService sapCheckOptionService;
	@Autowired
	private SapEmployeeTimeService employeeTimeService;
	@Autowired
	private SapApprovalInfoService sapApprovalInfoService;

	/**
	 * http://localhost:8080/sapcms/report/initReport
	 * 
	 * @return
	 */
	@RequestMapping(value = "/initReport", produces = "application/json;charset=utf-8")
	@ResponseBody
	public Object initReport() {
		try {
			Date startDate = DateUtil.sdfTime.parse("2020-05-11 00:00:00");
			Date endDate = DateUtil.sdfTime.parse("2020-05-15 23:59:59");
			wxDepartService.saveDeparts(); // ok
			wxUserService.saveUsers(); // ok
			sapCheckService.saveAllUserCheckData(startDate, endDate);
			employeeTimeService.saveEmployeeTimes(); // ok
			sapCheckOptionService.saveOptions(); // ok
			sapApprovalInfoService.saveApprovalInfos(DateUtil.sdfYear_MMonth.format(endDate)); // ok
			return AppUtil.success();
		} catch (Exception e) {
			LoggerUtil.error(e);
			return AppUtil.error(ResultConstant.WEB_ERR_MSG);
		}
	}

	/**
	 * http://localhost:8080/sapcms/report/saveReport
	 * 
	 * @return
	 */
	@RequestMapping(value = "/saveReport", produces = "application/json;charset=utf-8")
	@ResponseBody
	public Object saveReport() {
		try {
			sapCheckService.updateReportBaseData();
			sapCheckService.saveReportResultData();
			return AppUtil.success();
		} catch (Exception e) {
			LoggerUtil.error(e);
			return AppUtil.error(ResultConstant.WEB_ERR_MSG);
		}
	}
}